stages:
  - lint
  - test
  - build

variables:
  GIT_SUBMODULE_STRATEGY: recursive

.python_common: &python_common
  image: "python:3.7"
  before_script:
    - python --version
    - pip install flake8==3.8.3
    - pip install pytest==5.4.3 pytest-cov==2.10.0

run flake8:
  <<: *python_common
  stage: lint
  script:
    - flake8 --exclude=.env --max-line-length=90

run install:
  <<: *python_common
  stage: test
  script:
    - ./install.sh

run pytest:
  <<: *python_common
  stage: test
  script:
    - ./install.sh
    - pytest --cov=oven_optimizer
  except:
    - tags

build docker:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor
      --context $CI_PROJECT_DIR
      --dockerfile $CI_PROJECT_DIR/Dockerfile
      --destination $CI_REGISTRY_IMAGE:latest
  only:
    - master
